﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SequencionReader.SequencionTypes
{
    public class FibonacciSequencion : ISequencion
    {
        public double[] Compute(double[] sequencion, int number)
        {
            double[] result = new double[sequencion.Length];
            for (int i = result.Length; i < result.Length + number; i++)
                result[i - result.Length] = GetFibNumberByIndex(i);
            return result;
        }

        public double GetFibNumberByIndex(int number)
        {
            if (number == 0) return 0;
            if (number == 1 || number == 2) return 1;

            int[] Fib = new int[number + 1];
            Fib[0] = 0;
            Fib[1] = 1;

            for (int i = 2; i <= number; i++)
                Fib[i] = Fib[i - 2] + Fib[i - 1];

            return Fib[number];
        }

        public bool Is(double[] sequencion)
        {
            bool result = false;
            for (int i = 0; i < sequencion.Length; i++)
            {
                if (!IsFibonacci(sequencion[i]))
                {
                    result = false;
                    break;
                }
                else result = true;
            }
            return result;
        }

        public bool IsFibonacci(double number)
        {
            double fi = (1 + Math.Sqrt(5)) / 2.0;
            int n = (int)Math.Floor(Math.Log(number * Math.Sqrt(5) + 0.5, fi));
            double actualFibonacciNumber = (int)Math.Floor(Math.Pow(fi, n) / Math.Sqrt(5) + 0.5);
            return actualFibonacciNumber == number;
        }
    }
}
