﻿using SequencionReader.ApproximationFunctions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SequencionReader.SequencionTypes
{
    class GeneralSequencion : ISequencion
    {
        private IApproximationFunction approxFunctions;

        public GeneralSequencion(IApproximationFunction func)
        {
            this.approxFunctions = func;
        }

        public double[] Compute(double[] sequencion, int number)
        {
            double[] result = new double[number];
            double[] xValues = CreateXValues(number);

            this.approxFunctions.DefinePolynomial(xValues, sequencion);

            for (int i = sequencion.Length; i < number + sequencion.Length; i++)
                result[i - sequencion.Length] = this.approxFunctions.Compute(i);
            return result;
        }

        public bool Is(double[] sequencion)
        {
            return true;
        }

        private double[] CreateXValues(int lenght)
        {
            double[] result = new double[lenght];
            for (int i = 0; i < lenght; i++)
                result[i] = i;
            return result;
        }
    }
}
