﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SequencionReader.SequencionTypes
{
    class GeometricSequencion : ISequencion
    {
        public double[] Compute(double[] sequencion, int number)
        {
            double[] result = null;
            if (sequencion.Count() > 1)
            {
                result = new double[number];
                double q = Math.Abs(sequencion[1]) / Math.Abs(sequencion[0]);
                double firstItem = Math.Abs(sequencion[0]);

                bool decreasing = sequencion[1] < sequencion[0];

                int n = sequencion.Length;

                for (int i = 0; i < result.Length; i++)
                {
                    double rightSide = Math.Pow(q, n);
                    if (decreasing) rightSide *= -1;
                    result[i] = firstItem * rightSide;
                    n++;
                }

            }
            return result;
        }

        public bool Is(double[] sequencion)
        {
            bool result = false;
            if (sequencion.Count() > 1)
            {
                double ratio = Math.Abs(sequencion[1]) / Math.Abs(sequencion[0]);
                for (int i = 1; i < sequencion.Length - 1; i++)
                {
                    double tempRatio = Math.Abs(sequencion[i + 1]) / Math.Abs(sequencion[i]);
                    if (ratio != tempRatio) return false;
                }
                result = true;
            }
            return result;
        }
    }
}
